/* part_db.c - simulated database access to parts */
#include "local.h"
#include "part.h"
static PART parts[3] = {0};
static short n_part = 0;

/* db_locate_part -- see if a part is in the database */
static int db_locate_part(partp)
	PART *partp;
	{
	short i;

	for (i = 0; i < n_part; ++i)
		if (STREQ(partp->part_no, parts[i].part_no))
			return (i);		/* this is the part, return its index */
	return (-1); /* no part from 0 to n_part matches this part_no */
	}																					                                                                         /*
.PE
.PS 13
/* db_add_part - add a part record to database */
bool db_add_part(partp)
	PART *partp;
	{
	if (n_part >= DIM(parts))
		{
		remark("Part storage is full", "");
		return (NO);
		}
	STRUCTASST(parts[n_part], *partp);
	++n_part;
	return (YES);
	}																					                                                                         /*
.PE
.PS 12
/* db_find_part - find a part record in database */
bool db_find_part(partp)
	PART *partp;
	{
	short i;

	i = db_locate_part(partp);
	if (i == -1)
		return(NO);
	STRUCTASST(*partp, parts[i]);
	return(YES);
	}																				                                                              /* 
.PE
.PS 17
/* db_del_part - delete a part record in database */
bool db_del_part(partp)
	PART *partp;
	{
	short i;

	for (i = 0; i < n_part; ++i)
		{
		if (STREQ(partp->part_no, parts[i].part_no))
			{
			--n_part;
			STRUCTASST(parts[i], parts[n_part]);
			return (YES);
			}
		}
	return (NO);
	}																					                                                                         /*
.PE
.PS 16
/* db_chg_part - change a part record in database */
bool db_chg_part(partp)
	PART *partp;
	{
	short i;

	for (i = 0; i < n_part; ++i)
		{
		if (STREQ(partp->part_no, parts[i].part_no))
			{
			STRUCTASST(parts[i], *partp);
			return (YES);
			}
		}
	return (NO);
	}																					                                                                         /*
.PE
.PS 12
/* db_open_part - open the parts database
 * Dummy - no action needed
 */
void db_open_part()
	{
	}
/* db_close_part - close the parts database
 * Dummy - no action needed
 */
void db_close_part()
	{
	}
